## openmolcas 23.10

=== CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#                                                                      *
# Copyright (C) 2014-2016, Steven Vancoillie                           *
#               2014-2023, Ignacio Fdez. Galván                        *
#               2015, Stefan Knecht                                    *
#               2020, Gerardo Raggi                                    *
#***********************************************************************
# Global CMakeLists.txt file for building OpenMolcas with CMake.
#
# Steven Vancoillie - Spring 2014, on a Saturday afternoon, with coffee
# Ignacio Fdez. Galván made several improvements / additions
# Gerardo Raggi - AppleClang

cmake_minimum_required (VERSION 3.12)
cmake_policy (VERSION 3.12...3.21)

project (OpenMolcas
         LANGUAGES Fortran C
         VERSION ""
)

#set (CMAKE_VERBOSE_MAKEFILE ON)

include (${PROJECT_SOURCE_DIR}/cmake/cmake_helpers.cmake)

# Prevent in-source builds
# If an in-source build is attempted, you will still need to clean up a few files manually.
set (CMAKE_DISABLE_SOURCE_CHANGES ON)
set (CMAKE_DISABLE_IN_SOURCE_BUILD ON)
get_filename_component (sourcedir "${CMAKE_SOURCE_DIR}" REALPATH)
get_filename_component (binarydir "${CMAKE_BINARY_DIR}" REALPATH)
if ("${sourcedir}" STREQUAL "${binarydir}")
  message (FATAL_ERROR "In-source builds in ${CMAKE_BINARY_DIR} are not "
          "allowed, please remove ./CMakeCache.txt and ./CMakeFiles/, create a "
          "separate build directory and run cmake from there.")
endif ()

# discover some necessary tools
find_program (GIT "git")
find_program (PERL "perl")
mark_as_advanced (FORCE GIT PERL)

FIND_PACKAGE (Python COMPONENTS Interpreter)

################################################################################
#                                                                              #
# Options                                                                      #
#                                                                              #
################################################################################

# The build type, specifies the different optimization types.
if (NOT DEFINED CMAKE_BUILD_TYPE OR "${CMAKE_BUILD_TYPE}" STREQUAL "")
  set (CMAKE_BUILD_TYPE "Release" CACHE STRING
       "Type of build, options are: None (CFLAGS/FFLAGS can be used), Debug, Garble, RelWithDebInfo, Release, Fast."
       FORCE)
endif ()
set_property (CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS None Debug Garble RelWithDebInfo Release Fast)

# The place where OpenMolcas is installed with make install.
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set (CMAKE_INSTALL_PREFIX "/opt/OpenMolcas" CACHE PATH "Location where OpenMolcas will be installed." FORCE)
endif ()
set (EXTRA_INSTALL_TARGETS "")
set (EXTRA_INSTALL_DIRS "")
set (EXTRA_INSTALL_IMPORTED_LIBS "")

option (INSTALL_TESTS "Install the test files and verify script." OFF)

set (DEBUG_DEFS "${DEBUG_DEFS}" CACHE STRING "Additional user-supplied definitions.")
separate_arguments (DEBUG_DEFS)

option (BUILD_SHARED_LIBS "Build dynamically-linked libraries." OFF)
option (BUILD_STATIC_LIBS "Build statically-linked libraries too." OFF)
if (BUILD_SHARED_LIBS)
  mark_as_advanced (CLEAR BUILD_STATIC_LIBS)
else ()
  mark_as_advanced (FORCE BUILD_STATIC_LIBS)
endif ()

option (MPI "Enable MPI parallellization." OFF)
option (GA "Use Global Arrays library." OFF)

option (OPENMP "Enable multi-threading." OFF)
option (IPO "Enable interprocedural optimization (if supported)." OFF)

option (BOUNDS "Enable bounds checking (only GNU Fortran)." OFF)

option (EXPERT "Show advanced compiler flags in CMake GUI)." OFF)

option (BIGOT "Do not allow any compiler warning (treat them as errors)." OFF)

set (LINALG_OPTIONS "Choose linear algebra library, options: Internal (default), Runtime, MKL, OpenBLAS, AOCL, Accelerate, Manual.")
if (DEFINED LINALG)
  set (LINALG "${LINALG}" CACHE STRING "${LINALG_OPTIONS}")
  if (NOT ";Internal;Runtime;MKL;OpenBLAS;AOCL;Accelerate;Manual;" MATCHES ";${LINALG};")
      message (FATAL_ERROR "Unsuported LINALG: ${LINALG}")
  endif ()
else ()
  set (LINALG "Internal" CACHE STRING "${LINALG_OPTIONS}")
endif ()
set_property (CACHE LINALG PROPERTY STRINGS Internal Runtime MKL OpenBLAS AOCL Accelerate Manual)

option (CUBLAS "Enable CUDA BLAS library." OFF)
option (NVBLAS "Enable NVidia BLAS library." OFF)

set (EXTERNAL_LIBXC "" CACHE STRING "Location for an external Libxc build")

option (FDE "Enable Frozen-density-embedding (FDE) interface." OFF)
option (GROMACS "Compile Gromacs interface." OFF)
option (BLOCK "Activate BLOCK-DMRG support." OFF)
option (CHEMPS2 "Activate CheMPS2-DMRG support." OFF)
option (DICE "Activate Dice-SHCI support." OFF)

option (GPERFTOOLS "Activate gperftools CPU profiling." OFF)
option (GCOV "Activate code coverage profiling (use with Debug/-O0)." OFF)
option (HDF5 "Activate HDF5 support for wavefunction format." ON)

option (TOOLS "Compile supported tools." OFF)

option (BUILD_TESTING "Build the unit_tests." ON)

if (";Debug;Garble;" MATCHES ";${CMAKE_BUILD_TYPE};")
  add_compile_definitions (_ADDITIONAL_RUNTIME_CHECK_)
endif ()

if (";Debug;Garble;RelWithDebInfo;" MATCHES ";${CMAKE_BUILD_TYPE};" OR
    CMAKE_Fortran_COMPILER_ID STREQUAL "NAG" OR
    BIGOT)
  add_compile_definitions (_WARNING_WORKAROUND_)
endif ()

# External projects
option (DMRG     "Activate QCMaquis DMRG driver and library."                                                 OFF)
option (EFPLIB   "Enable EFPLib library for effective fragment potentials (requires External/efp submodule)." OFF)
option (GA_BUILD "Build Global Arrays."                                                                       OFF)
option (GEN1INT  "Enable Gen1Int library for 1-electron integrals."                                           OFF)
option (MolGUI   "Enable the Molcas Graphical User Interface."                                                OFF)
option (MSYM     "Activate MSYM support (requires External/libmsym submodule)."                               OFF)
option (NECI     "Activate NECI support (requires External/NECI submodule)."                                  OFF)
option (NEVPT2   "Activate (DMRG)-NEVPT2 support."                                                            OFF)
option (WFA      "Activate extended wavefunction analysis (requires External/libwfa submodule)."              OFF)

################################################################################
#                                                                              #
# Global settings                                                              #
#                                                                              #
################################################################################

# mark that we are running CMake (for subprocesses)
set (ENV{CMAKE_SESSION} "OpenMolcas")

# project name and supported languages
#=====================================
message ("Configuring compilers:")

if (WFA OR MolGUI OR DMRG)
  enable_language (CXX)
endif ()

#avoid using CXX compiler for linking
set (CMAKE_CXX_LINKER_PREFERENCE_PROPAGATES "FALSE")

add_compile_definitions (_MOLCAS_)

#set cmake module search paths
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH})

# location of molcas-extra
if (NOT DEFINED EXTRA)
  if (DEFINED ENV{EXTRA})
    set (EXTRA $ENV{EXTRA})
  else ()
    set (EXTRA "")
  endif ()
endif ()
if (NOT "${EXTRA}" STREQUAL "")
  if (NOT IS_ABSOLUTE "${EXTRA}")
    set (EXTRA "${PROJECT_BINARY_DIR}/${EXTRA}")
  endif ()
  get_filename_component (EXTRA "${EXTRA}" ABSOLUTE)
  if (NOT EXISTS "${EXTRA}")
    message (WARNING "The molcas-extra directory ${EXTRA} does not exist.")
  else ()
    FILE (STRINGS "${EXTRA}/.molcashome" DIR_TYPE)
    if ("${DIR_TYPE}" STREQUAL "molcas-extra")
      set (EXTRA_DIR ${EXTRA})
      add_compile_definitions (_HAVE_EXTRA_)
    else ()
      message (FATAL_ERROR "The directory ${EXTRA} does not contain molcas-extra.")
    endif ()
  endif ()
endif ()
set (EXTRA "${EXTRA}" CACHE PATH "Location of the molcas-extra directory." FORCE)

# possible locations for source code
set (OPENMOLCAS_DIR ${CMAKE_CURRENT_LIST_DIR})
if (NOT ${PROJECT_SOURCE_DIR} STREQUAL ${OPENMOLCAS_DIR})
  set (basedirs ${PROJECT_SOURCE_DIR})
  set (EXTRA_DIR ${PROJECT_SOURCE_DIR})
  add_compile_definitions (_HAVE_EXTRA_)
endif ()
list (APPEND basedirs ${OPENMOLCAS_DIR})
if (NOT "${EXTRA}" STREQUAL "")
  if (NOT ";${basedirs};" MATCHES ";${EXTRA};")
    list (APPEND basedirs ${EXTRA})
  endif ()
endif ()
foreach (BASE_DIR ${basedirs})
  file (GLOB source_roots_tmp RELATIVE ${PROJECT_SOURCE_DIR} "${BASE_DIR}/src*")
  list (SORT source_roots_tmp)
  list (APPEND source_roots ${source_roots_tmp})
endforeach ()
list (REVERSE basedirs)

# get version from git if available, otherwise look in .molcasversion
#====================================================================

message ("Detecting Molcas version info:")

set (ENV{MOLCAS} ${PROJECT_BINARY_DIR})
set (ENV{OPENMOLCAS} ${OPENMOLCAS_DIR})
if (DEFINED EXTRA_DIR)
  set (ENV{MOLCAS_SOURCE} ${EXTRA_DIR})
else ()
  set (ENV{MOLCAS_SOURCE} ${OPENMOLCAS_DIR})
endif ()

execute_process (
  COMMAND ${GIT} "rev-parse" "--git-dir"
  WORKING_DIRECTORY ${OPENMOLCAS_DIR}
  OUTPUT_VARIABLE GIT_REVPARSE_OUTPUT
  ERROR_VARIABLE GIT_REVPARSE_ERROR
  RESULT_VARIABLE GIT_REVPARSE_RC
  OUTPUT_STRIP_TRAILING_WHITESPACE
)
if (GIT_REVPARSE_RC)
  set (OPENMOLCAS_GIT_REPO "${OPENMOLCAS_DIR}/.git")
else ()
  set (OPENMOLCAS_GIT_REPO "${GIT_REVPARSE_OUTPUT}")
  if (NOT IS_ABSOLUTE "${OPENMOLCAS_GIT_REPO}")
    set (OPENMOLCAS_GIT_REPO "${OPENMOLCAS_DIR}/${OPENMOLCAS_GIT_REPO}")
  endif ()
endif ()
set (MOLCAS_VERSION_FILE "${PROJECT_SOURCE_DIR}/.molcasversion")

if (DEFINED EXTRA_DIR)
  execute_process (
    COMMAND ${GIT} "rev-parse" "--git-dir"
    WORKING_DIRECTORY ${EXTRA_DIR}
    OUTPUT_VARIABLE GIT_REVPARSE_OUTPUT
    ERROR_VARIABLE GIT_REVPARSE_ERROR
    RESULT_VARIABLE GIT_REVPARSE_RC
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  if (GIT_REVPARSE_RC)
    set (EXTRA_GIT_REPO "${EXTRA_DIR}/.git")
  else ()
    set (EXTRA_GIT_REPO "${GIT_REVPARSE_OUTPUT}")
    if (NOT IS_ABSOLUTE "${EXTRA_GIT_REPO}")
      set (EXTRA_GIT_REPO "${EXTRA_DIR}/${EXTRA_GIT_REPO}")
    endif ()
  endif ()
endif ()

if (EXISTS ${GIT})
  foreach (BASE_DIR ${basedirs})
    if ("${BASE_DIR}" STREQUAL "${OPENMOLCAS_DIR}")
      if (EXISTS ${OPENMOLCAS_GIT_REPO})
        set (MOLCAS_GIT_REPO ${OPENMOLCAS_GIT_REPO})
      else ()
        continue ()
      endif ()
      set (label "")
    elseif ("${BASE_DIR}" STREQUAL "${EXTRA_DIR}")
      if (EXISTS ${EXTRA_GIT_REPO})
        set (MOLCAS_GIT_REPO ${EXTRA_GIT_REPO})
      else ()
        continue ()
      endif ()
      set (label "-extra")
    endif ()
    # always set the HEAD as a source for configuring
    configure_file ("${MOLCAS_GIT_REPO}/HEAD" git-head${label} COPYONLY)
    # if it is a ref to a named branch, include the branch ref too
    file (READ "${MOLCAS_GIT_REPO}/HEAD" HEAD_STRING)
    string (STRIP "${HEAD_STRING}" HEAD_STRING)
    string (REPLACE "ref: " "" HEAD_REF "${HEAD_STRING}")
    if (EXISTS "${MOLCAS_GIT_REPO}/${HEAD_REF}")
      configure_file ("${MOLCAS_GIT_REPO}/${HEAD_REF}" git-head-ref${label} COPYONLY)
    endif ()
    # now, get the actual versions from the git describe tool

=== unit_tests/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#                                                                      *
# Copyright (C) 2020, Oskar Weser                                      *
#***********************************************************************

include_guard(GLOBAL)

include(${PROJECT_SOURCE_DIR}/cmake/cmake_helpers.cmake)

# unsupported compilers
set(not_supported ";SunPro;PGI;")

set(UNIT_TEST_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR})

set(all_tests "")

function(add_unit_test Target)
    add_directory(../fruit_molcas)

    add_executable(${Target} ${ARGN})

    target_link_libraries(${Target} fruit_molcas libmolcas ${EXTERNAL_LIBRARIES})

    set_target_properties(${Target}
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY
            "${UNIT_TEST_BUILD_DIR}/bin")

    add_test(
        NAME
            ${Target}
        COMMAND
            $<TARGET_FILE:${Target}>)

    list(APPEND all_tests ${Target})
    set(all_tests ${all_tests} PARENT_SCOPE)

    set_tests_properties(
        ${Target}
        PROPERTIES
            ENVIRONMENT "MOLCAS_MEM=256"
            FIXTURES_REQUIRED "test_fixture")
endfunction()

macro(add_test_directory SubDir)
    add_subdirectory(${SubDir}/)
    get_directory_property(all_tests DIRECTORY ${SubDir} DEFINITION all_tests)
endmacro()

# start adding tests, but don't bother with shitty compilers
if (NOT ((CMAKE_Fortran_COMPILER_ID IN_LIST not_supported) OR (CMAKE_Fortran_COMPILER_ID STREQUAL "Intel" AND CMAKE_Fortran_COMPILER_VERSION VERSION_LESS "14")))
    add_test_directory(linalg_mod/)
    add_test_directory(fortran_strings/)
    add_test_directory(sorting/)
    add_test_directory(filesystem/)

    add_custom_target(build_tests)
    add_dependencies(build_tests ${all_tests})

    add_test(test_build
        "${CMAKE_COMMAND}"
        --build "${CMAKE_BINARY_DIR}"
        --config "$<CONFIG>"
        --target build_tests
    )

    set_tests_properties(
        test_build
        PROPERTIES
            FIXTURES_REQUIRED "test_fixture")
endif()

=== Tools/grid2cube/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#                                                                      *
# Copyright (C) 2015,2016,2020, Ignacio Fdez. Galván                   *
#***********************************************************************
if (NOT DEFINED BASE_DIR)
  set (BASE_DIR ${PROJECT_SOURCE_DIR})
endif ()
file (RELATIVE_PATH tooldir ${BASE_DIR} ${CMAKE_CURRENT_LIST_DIR})
set (EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/${tooldir})

foreach (prog IN ITEMS grid2cube)
  add_executable (${prog}.exe ${prog}.F90)
  file (COPY ${CMAKE_CURRENT_LIST_DIR}/${prog}.py
        DESTINATION ${EXECUTABLE_OUTPUT_PATH}
  )
  install (PROGRAMS
           ${EXECUTABLE_OUTPUT_PATH}/${prog}.exe
           ${EXECUTABLE_OUTPUT_PATH}/${prog}.py
           DESTINATION ${CMAKE_INSTALL_PREFIX}/${tooldir}
  )
endforeach (prog)

=== Tools/pymolcas/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#                                                                      *
# Copyright (C) 2017,2020, Ignacio Fdez. Galván                        *
#***********************************************************************
if (NOT DEFINED BASE_DIR)
  set (BASE_DIR ${PROJECT_SOURCE_DIR})
endif ()
file (RELATIVE_PATH tooldir ${BASE_DIR} ${CMAKE_CURRENT_LIST_DIR})
set (OUTPUT_PATH ${PROJECT_BINARY_DIR}/)

file (GLOB py_sources "*.py")
list (REMOVE_ITEM py_sources "${CMAKE_CURRENT_LIST_DIR}/pack.py")

if (NOT Python_FOUND)
  set (dir_error "disabled (no appropriate Python interpreter found)" PARENT_SCOPE)
  return ()
endif ()

set (Python_FOUND "${Python_FOUND}" PARENT_SCOPE)

execute_process (COMMAND ${Python_EXECUTABLE} imports.py
                 WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
                 OUTPUT_VARIABLE PYMOLCAS_IMPORT_OUTPUT
                 RESULT_VARIABLE PYMOLCAS_IMPORT_RC
                 OUTPUT_STRIP_TRAILING_WHITESPACE
)

if (PYMOLCAS_IMPORT_RC)
  message (WARNING "Some Python modules are not available: ${PYMOLCAS_IMPORT_OUTPUT}")
  set (dir_error "disabled" PARENT_SCOPE)
  return ()
endif ()

set (PYMOLCAS_SCRIPT "${OUTPUT_PATH}/pymolcas")
set (PYMOLCAS_SCRIPT "${PYMOLCAS_SCRIPT}" PARENT_SCOPE)

# Note the command and the target must have different names
add_custom_command (OUTPUT ${PYMOLCAS_SCRIPT}
                    COMMAND ${Python_EXECUTABLE} export.py ${PYMOLCAS_SCRIPT}
                    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
                    DEPENDS ${py_sources}
)

add_custom_target (pymolcas_target ALL
                   DEPENDS ${PYMOLCAS_SCRIPT}
)

=== src/alaska_util/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************

set (sources
     cmbnm2.F90
     cmbnmlt1.F90
     cmbnrf1.F90
     cmbns1.F90
     cmbnt1.F90
     cmbnw1.F90
     cosgrd.F90
     create_grads.F90
     csfgrad.F90
     drvh1.F90
     finfld.F90
     grd_interface.F90
     int_parm_g.F90
     int_prep_g.F90
     knegrd.F90
     knemmg.F90
     m1grd.F90
     m1mmg.F90
     m2grd.F90
     m2mmg.F90
     mltgrd.F90
     mltgrdnuc.F90
     mltmmg.F90
     nagrd.F90
     nammg.F90
     oneel_g.F90
     ovrgrd.F90
     ovrmmg.F90
     pcmgrd.F90
     pcmmmg.F90
     prepre_g.F90
     prgrad.F90
     prjgrd.F90
     prjmmg.F90
     psoao1.F90
     query_grads.F90
     read_grad.F90
     rfgrd.F90
     rfmmg.F90
     screen_g.F90
     size_sob_g.F90
     soao_g.F90
     srogrd.F90
     srommg.F90
     store_grad.F90
     store_not_grad.F90
     twoel_g.F90
     welgrd.F90
     welmmg.F90
     xfdgrd.F90
     xfdmmg.F90
)

# Source files defining modules that should be available to other *_util directories
set (modfile_list
     grd_interface.F90
)

include (${PROJECT_SOURCE_DIR}/cmake/util_template.cmake)

=== src/amfi_util/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************

set (sources
     amfi.F90
     amfi_global.F90
     angular.F90
     buildcoul.F90
     cartonex.F90
     cartoney.F90
     cartonez.F90
     chngcont.F90
     contandmult.F90
     contcasaoo.F90
     contcasaso.F90
     contcasb1oo.F90
     contcasb1so.F90
     contcasb2oo.F90
     contcasb2so.F90
     contcascoo.F90
     contcascso.F90
     cont.F90
     contone.F90
     contract.F90
     couple3j.F90
     daxpint.F90
     drv_amfi.F90
     finite.F90
     gen1overr3.F90
     gencouldim.F90
     gencoul.F90
     genovlp.F90
     genpowers.F90
     genprexyz13.F90
     genprexyz14.F90
     genprexyz15a.F90
     gentkin.F90
     getaos2.F90
     getaos.F90
     getcg.F90
     getlimit.F90
     getocc_ao.F90
     inidf.F90
     initfrac.F90
     initired.F90
     kindiag.F90
     kinemat.F90
     lmdepang.F90
     mcheckxy.F90
     mcheckz.F90
     mkangl0.F90
     mkanglmin.F90
     prefac.F90
     readbas.F90
     regge3j.F90
     symtrafo.F90
     tkinet.F90
     tosigx.F90
     tosigy.F90
     tosigz.F90
     trans_amfi.F90
     transcon.F90
     two2mean12a.F90
     two2mean12b.F90
     two2mean13.F90
     two2mean34a.F90
     two2mean34b.F90
)

# Source files defining modules that should be available to other *_util directories
set (modfile_list "")

include (${PROJECT_SOURCE_DIR}/cmake/util_template.cmake)

=== src/ccsd_util/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************

set (sources
     add10.F90
     add21.F90
     add22.F90
     add32.F90
     add41.F90
     add42.F90
     add43.F90
     add44.F90
     add.F90
     calcr.F90
     calcrh1.F90
     ccmult.F90
     ccsd_exc.F90
     ccsd.F90
     ccsd_global.F90
     contf12.F90
     contf14.F90
     contf22.F90
     contf23.F90
     contf24.F90
     contf32.F90
     contf4.F90
     contf5.F90
     contt12.F90
     contt13.F90
     contt147.F90
     contt29.F90
     contw1.F90
     diiscf.F90
     diis.F90
     diish1.F90
     diish2.F90
     diish3.F90
     diisof.F90
     diisra.F90
     diisrf.F90
     diiswa1.F90
     distnodes.F90
     divfok.F90
     divt.F90
     divthelp1.F90
     divthelp2.F90
     divthelp3.F90
     expand0.F90
     expand1.F90
     expand2.F90
     expand3.F90
     expand40.F90
     expand41.F90
     expand.F90
     extstack.F90
     extstackhlp1.F90
     fack.F90
     filemanager.F90
     finale.F90
     fokunpck1.F90
     fokunpck2.F90
     fokunpck3.F90
     fokunpck4.F90
     fokunpck5.F90
     getmap.F90
     getmediate.F90
     getw3.F90
     grc0.F90
     grc0stack.F90
     grc22c.F90
     grc23c.F90
     grc24c.F90
     grc32c.F90
     grc32y.F90
     grc33c.F90
     grc34c.F90
     grc42c.F90
     grc42y.F90
     grc43c.F90
     grc43y.F90
     grc44c.F90
     init.F90
     initfiles.F90
     intermezzo.F90
     joinamplitudes.F90
     map11.F90
     map21.F90
     map22.F90
     map31.F90
     map32.F90
     map41.F90
     map42.F90
     map.F90
     max5.F90
     max5h1.F90
     max5h2.F90
     mc0c1a3b.F90
     mc0c1at3b.F90
     mkfilemgrcom.F90
     mkq.F90
     mkqhelp1.F90
     mkqhelp2.F90
     mktau.F90
     mktauhelp1.F90
     mktauhelp2.F90
     mr0u3wt.F90
     multc0.F90
     multdot.F90
     multstack.F90
     multy0.F90
     mv0v1a3u.F90
     noperm.F90
     pack210.F90
     pack211.F90
     pack310.F90
     pack311.F90
     pack320.F90
     pack321.F90
     percentzero.F90
     rea.F90
     reainput.F90
     reaintsta.F90
     reajalovy.F90
     redef.F90
     saamp.F90
     saamphlp1.F90
     saamphlp2.F90
     saamphlp3.F90
     saverest1.F90
     saverest2.F90
     set0.F90
     sumabdistt.F90
     sumoverab.F90
     sumovera.F90
     unpackab1.F90
     unpackab2.F90
     unpackab3.F90
     unpckhelp10.F90
     unpckhelp11.F90
     unpckhelp1.F90
     unpckhelp2.F90
     unpckhelp3.F90
     unpckhelp4.F90
     unpckhelp5.F90
     unpckhelp6.F90
     unpckhelp7.F90
     unpckhelp8.F90
     unpckhelp9.F90
     wrhead.F90
     wri.F90
     wrtmap.F90
     wrtmediate.F90
)

# Source files defining modules that should be available to other *_util directories
set (modfile_list "")

include (${PROJECT_SOURCE_DIR}/cmake/util_template.cmake)

=== src/ccsdt/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************

set (sources
     main.F90
     ccsdt.F90
)

include (${PROJECT_SOURCE_DIR}/cmake/prog_template.cmake)

=== src/ccsort_util/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************

set (sources
     abpack.F90
     action_ccsort.F90
     addintabc1.F90
     addintab.F90
     addinta.F90
     addpqij.F90
     ampack.F90
     ccsort_global.F90
     ccsort_grc0.F90
     ccsort_t3grc0.F90
     chkinp_ccsort.F90
     daopen.F90
     daread.F90
     dawri.F90
     dawrite.F90
     dawrtmap.F90
     dawrtmediate.F90
     deflength.F90
     deft3par.F90
     esb_ic_1.F90
     esb_ic_2.F90
     esb_ic_3.F90
     expandfok.F90
     expmpq.F90
     exppqij.F90
     exppsb.F90
     fokupdate1.F90
     fokupdate2.F90
     initintabc1.F90
     inittemp.F90
     initwrk.F90
     ireorg1.F90
     ireorg2.F90
     ireorg3.F90
     ireorg.F90
     mkabpqmap.F90
     mkaddress.F90
     mkampq.F90
     mkampqmap.F90
     mkintsta.F90
     mkmapampq.F90
     mkmappqij.F90
     mktempanam.F90
     mod1.F90
     mod2.F90
     mreorg1.F90
     mreorg.F90
     prinppn.F90
     rdinppn.F90
     rdtraone.F90
     reorg.F90
     t3intpck1.F90
     t3intpck2.F90
     t3reorg.F90
     unpackk.F90
     unpackk_ic_1.F90
     unpackk_ic_2.F90
     unpackk_ic_3.F90
     unpackk_pck.F90
     unpackk_zr.F90
     vf.F90
     zasun.F90
     zasun_pck.F90
     zasun_zr.F90
)

# Source files defining modules that should be available to other *_util directories
set (modfile_list "")

include (${PROJECT_SOURCE_DIR}/cmake/util_template.cmake)

=== src/chcc/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************

set (sources
     adh_hvv2.F90
     adt_t17.F90
     adv_a23.F90
     adv_g2.F90
     autosegmentation.F90
     calc_addg.F90
     calcaddpp.F90
     calc_addsg.F90
     calc_bc.F90
     chcc.F90
     chcc_global.F90
     chck_0.F90
     chck_aa.F90
     chck_a.F90
     chck_b.F90
     chck_energ.F90
     chck_goo.F90
     chck_gvv.F90
     chck_h1.F90
     chck_hoo.F90
     chck_hvo.F90
     chck_hvv.F90
     chck_k.F90
     chck_l1.F90
     chck_l2.F90
     chck_mkj.F90
     chck_mkk.F90
     chck_q.F90
     chck_t17g.F90
     chck_t1.F90
     chck_t1g.F90
     chck_t21.F90
     chck_t21od.F90
     chck_t2n.F90
     chck_t2p.F90
     chck_t2sym.F90
     chck_th.F90
     chck_tjedna.F90
     chck_tx.F90
     chck_v.F90
     chck_vx.F90
     chck_w1.F90
     chck_w2p.F90
     chck_w31.F90
     chck_w3.F90
     chck_w4.F90
     chck_x.F90
     chck_xred.F90
     chck_y.F90
     checkmem.F90
     cho_cc_drv.F90
     cve2.F90
     defparo2v4.F90
     defparo3v3.F90
     defparo3v3hlp1.F90
     defparo3v3hlp2.F90
     defparreord.F90
     defw34y.F90
     defw3y.F90
     defw4abcd.F90
     defw4abdc.F90
     defw4bacd.F90
     defw4badc.F90
     defw4cdab.F90
     defw4cdba.F90
     defw4dcab.F90
     defw4dcba.F90
     defw4y2.F90
     defw4y.F90
     dfh_hvv1.F90
     distmemchck.F90
     distmemo2v4.F90
     distmemo3v3chol.F90
     distmemo3v3jk.F90
     distmemo3v3t2.F90
     distmemperm.F90
     distmemreord.F90
     distmemsum.F90
     energy_e1.F90
     energy_e2d.F90
     energy_e2od.F90
     exa_x4.F90
     exh_t13.F90
     exh_x2.F90
     exp1.F90
     exp2.F90
     exp2i.F90
     exp4.F90
     expt2.F90
     ext_aex.F90
     ext_l0.F90
     ext_l1.F90
     ext_l2s.F90
     ext_l2u.F90
     extractm.F90
     extt1.F90
     ext_w3.F90
     ext_w4.F90
     ext_w4hlp1.F90
     ext_w4hlp2.F90
     ext_w4hlp3.F90
     exv_x41.F90
     exv_x42.F90
     exv_x43.F90
     findnexteffseg.F90
     frankie_drv.F90
     frankie_drv_fake.F90
     frankie.F90
     getchckdata.F90
     getchv.F90
     getchvhlp1.F90
     getchvhlp2.F90
     getchvhlp3.F90
     getchvhlp4.F90
     getrest.F90
     gett2n.F90
     gettau.F90
     gettauhlp1.F90
     gettauhlp2.F90
     getx.F90
     inireord.F90
     insl.F90
     insreaw3.F90
     insreaw4.F90
     insreqo2v4.F90
     joinlvec.F90
     main.F90
     makechckdata.F90
     maket2m.F90
     maket2pd.F90
     maket2pdhlp.F90
     maket2p.F90
     maket2phlp1.F90
     maket2phlp2.F90
     maket2phlp3.F90
     maket2pthlp1.F90
     maket2pthlp2.F90
     maket2pthlp3.F90
     makewwd.F90
     makewwdhlp1.F90
     makewwdhlp2.F90
     makeww.F90
     makewwhlp1.F90
     makewwhlp2.F90
     makewwhlp3.F90
     makewwhlp4.F90
     map2_21.F90
     map3_132.F90
     map3_213.F90
     map3_321.F90
     map4_1243.F90
     map4_1324.F90
     map4_1342.F90
     map4_1423.F90
     map4_1432.F90
     map4_2143.F90
     map4_2314.F90
     map4_3124.F90
     map4_3142.F90
     map4_3214.F90
     map4_3412.F90
     map4_3421.F90
     map4_4123.F90
     map4_4312.F90
     mc0c2a3b.F90
     mkd_q46.F90
     mke_y3.F90
     mki_q47.F90
     mkl0.F90
     mkl2_chcc.F90
     mknamev3.F90
     mknamev4.F90
     mkoe.F90
     mkq0.F90
     mkq1.F90
     mkq22.F90
     mkq3.F90
     mkq4.F90
     mkt1t2.F90
     mk_t1t.F90
     mkt20p.F90
     mkt20u.F90
     mktau_chcc.F90
     mkt_c136od.F90
     mkt_c245od.F90
     mkt_c78d.F90
     mkt_c78od.F90
     mkt_calld.F90
     mkt_exp.F90
     mkt_qk42.F90
     mkt_red.F90
     mkt_t15.F90
     mkt_t17.F90
     mkv_a1.F90
     mkv_a4.F90
     mkv_goo3.F90
     mkv_hoo2.F90
     mkv_hvo2.F90
     mkv_hvv2.F90
     mkv_k22.F90
     mkv_q22.F90
     mkv_t18.F90
     mo_transp.F90
     o2v4ctl.F90
     o2v4.F90
     o3v3chol.F90
     o3v3ctl.F90
     o3v3jk.F90
     o3v3t2.F90
     rea1.F90
     rea_chcc.F90
     read_mo.F90
     reaw3.F90
     reaw3hlp1.F90
     reaw3hlp2.F90
     reaw3hlp3.F90
     reaw4.F90
     reord_chcc.F90
     rnfill.F90
     savechckdata.F90
     saverest.F90
     savex.F90
     summary.F90
     t1_div.F90
     t2d_div.F90
     t2od_div.F90
     upg_t1.F90
     upg_t2d.F90
     upg_t2od.F90
     urobchv.F90
     urobi1.F90
     urobi2.F90
     urobi3.F90
     urobl1.F90
     urobl2.F90
     urobt2.F90
     urobtau.F90
     vanisht1.F90
     vanisht2n.F90
     wri_chcc.F90
     xo2v4ctl.F90
)

include (${PROJECT_SOURCE_DIR}/cmake/prog_template.cmake)

=== src/chemps2_util/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************

set (sources
     chemps2ctl.F90
     chemps2_densi_rasscf.F90
     chemps2_load2pdm.F90
     chemps2_load3pdm.F90
     irreps.F90
)

# Source files defining modules that should be available to other *_util directories
set (modfile_list "")

include (${PROJECT_SOURCE_DIR}/cmake/util_template.cmake)

=== src/cholesky_util/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************

set (sources
     alterr.F90
     ccd_incore.F90
     cd_decomposer.F90
     cd_diag.F90
     cd_diamax.F90
     cd_incore.F90
     cd_incore_1.F90
     cd_incore_1p.F90
     cd_incore_1p_w.F90
     cd_incore_p.F90
     cd_incore_p_w.F90
     cd_tester.F90
     cd_tester_col.F90
     cd_tester_cppf.F90
     cd_tester_diag.F90
     cd_tester_diff.F90
     cd_tester_es.F90
     cd_tester_final.F90
     cd_tester_mod.F90
     cd_tester_vec.F90
     checkdenomrange.F90
     chkacc.F90
     cho_1vecrd_sp.F90
     cho_allo_iscr.F90
     cho_anadia.F90
     cho_anasize.F90
     cho_calcdiag.F90
     cho_checkdiagfromz.F90
     cho_chkconf.F90
     cho_chkdia.F90
     cho_chkdia_a4.F90
     cho_chkint.F90
     cho_chkinto.F90
     cho_close.F90
     cho_cnvtim.F90
     cho_compvec.F90
     cho_dbgint.F90
     cho_dbgint_cho.F90
     cho_dec_qual.F90
     cho_decdrv.F90
     cho_decom.F90
     cho_decom_a4.F90
     cho_diacho.F90
     cho_diasp.F90
     cho_distrib_vec.F90
     cho_drv.F90
     cho_drv_inner.F90
     cho_drv_partwostep.F90
     cho_dump.F90
     cho_f2sp.F90
     cho_final.F90
     cho_gadgop.F90
     cho_gaigop.F90
     cho_get_er.F90
     cho_get_oed_cd.F90
     cho_get_ord_bj.F90
     cho_get_rij.F90
     cho_getdiag.F90
     cho_getdiag1.F90
     cho_getint.F90
     cho_getmaxshl.F90
     cho_getmq.F90
     cho_getred.F90
     cho_getrstc.F90
     cho_getstor.F90
     cho_getstor_s.F90
     cho_getvec.F90
     cho_getvec0.F90
     cho_getvec1.F90
     cho_getvec2.F90
     cho_getz.F90
     cho_gnvc_drv.F90
     cho_gnvc_genvec.F90
     cho_gnvc_getint.F90
     cho_head.F90
     cho_ifindsmallest.F90
     cho_inimap.F90
     cho_inirsdim.F90
     cho_init.F90
     cho_init1.F90
     cho_inp.F90
     cho_inp_setdecalg.F90
     cho_inpmod.F90
     cho_intchk_id_of.F90
     cho_intchk_reg.F90
     cho_invpck.F90
     cho_iodiag.F90
     cho_irange.F90
     cho_isao.F90
     cho_isaosh.F90
     cho_lread.F90
     cho_maxabsdiag.F90
     cho_maxabsdiag_1c.F90
     cho_maxdx.F90
     cho_mca_calcint.F90
     cho_mca_calcint_1.F90
     cho_mca_calcint_2.F90
     cho_mca_calcint_3.F90
     cho_mca_calcint_4.F90
     cho_mca_dbgint_a.F90
     cho_mca_dbgint_s.F90
     cho_mca_diagint.F90
     cho_mca_drv.F90
     cho_mca_getkey.F90
     cho_mca_init.F90
     cho_mca_int1_1_dbg2_cmp.F90
     cho_mca_int_1.F90
     cho_mca_int_1_dbg.F90
     cho_mca_int_1_dbg1.F90
     cho_mca_int_1_dbg2.F90
     cho_open.F90
     cho_openvr.F90
     cho_opfvec.F90
     cho_order.F90
     cho_outpak.F90
     cho_output.F90
     cho_p_anadia.F90
     cho_p_check.F90
     cho_p_chkint.F90
     cho_p_distrib_sp.F90
     cho_p_distrib_sp_bydim.F90
     cho_p_distrib_vec.F90
     cho_p_getgv.F90
     cho_p_getmaxshl.F90
     cho_p_getmq.F90
     cho_p_getqd.F90
     cho_p_indxparentdiag.F90
     cho_p_indxswp.F90
     cho_p_inilq.F90
     cho_p_localsp.F90
     cho_p_maxdx.F90
     cho_p_openr.F90
     cho_p_openvr.F90
     cho_p_prtdia.F90
     cho_p_prtred.F90
     cho_p_putred.F90
     cho_p_qualify.F90
     cho_p_qualswp.F90
     cho_p_reoqual.F90
     cho_p_setaddr.F90
     cho_p_setaddr_2.F90
     cho_p_setgl.F90
     cho_p_setlq.F90
     cho_p_setpass.F90
     cho_p_setred.F90
     cho_p_setred_l.F90
     cho_p_setshp2q.F90
     cho_p_setvecinf.F90
     cho_p_stat.F90
     cho_p_syncdiag.F90
     cho_p_syncnumcho.F90
     cho_p_updatebookmarks.F90
     cho_p_wrdiag.F90
     cho_p_wrrstc.F90
     cho_p_zerodiag.F90
     cho_p_zerodiag_rst.F90
     cho_pfake_getvec.F90
     cho_pfake_putvec.F90
     cho_pfake_vdist.F90
     cho_printlb.F90
     cho_prtdia.F90
     cho_prthead.F90
     cho_prtint.F90
     cho_prtmaxmem.F90
     cho_prtred.F90
     cho_prtst.F90
     cho_prttim.F90
     cho_pts_final.F90
     cho_pts_stat.F90
     cho_pts_wrrst.F90
     cho_putred.F90
     cho_putred1.F90
     cho_putvec.F90
     cho_putvec2.F90
     cho_qualify.F90
     cho_qualify_1.F90
     cho_qualify_2.F90
     cho_quit.F90
     cho_rdbuf.F90
     cho_rddbuf.F90
     cho_rdqcol_indx.F90
     cho_rdrstc.F90
     cho_reoini.F90
     cho_reoqual.F90
     cho_reordr.F90
     cho_reovc1.F90
     cho_reovec.F90
     cho_resetcnf.F90
     cho_restart.F90
     cho_rs2f.F90
     cho_rs2rs.F90
     cho_rscopy.F90
     cho_rstcnf.F90
     cho_rstd_chksp2f.F90
     cho_rstd_getind1.F90
     cho_rstd_getind2.F90
     cho_rstd_getind3.F90
     cho_rstmol.F90
     cho_rstof.F90
     cho_rword2byte.F90
     cho_setaddr.F90
     cho_setatomshl.F90
     cho_setdamp.F90
     cho_setdecalg_def.F90
     cho_setglob.F90
     cho_setmaxshl.F90
     cho_setmxshpr_def.F90
     cho_setpass.F90
     cho_setq2.F90
     cho_setred.F90
     cho_setredind.F90
     cho_setrsdim.F90
     cho_setsh.F90
     cho_setsh2.F90
     cho_setshp2q.F90
     cho_setshp2q_2.F90
     cho_setshp2rs.F90
     cho_setshp2rs_2.F90
     cho_setvecinf.F90
     cho_simri_z1cdia.F90
     cho_stat.F90
     cho_stat_parentdiag.F90
     cho_subscr_dia.F90
     cho_subscr_final.F90
     cho_subscr_init.F90
     cho_subtr.F90
     cho_subtr0.F90
     cho_subtr1.F90
     cho_tabind.F90
     cho_testbookmark.F90
     cho_testbookmark_1cinit.F90
     cho_testbookmark_prt.F90
     cho_translateerrorcode.F90
     cho_trcidl_init.F90
     cho_trcidl_report.F90
     cho_trcidl_update.F90
     cho_trdens.F90
     cho_vecbuf_check.F90
     cho_vecbuf_checkintegrity.F90
     cho_vecbuf_comparenormandsum.F90
     cho_vecbuf_copy.F90
     cho_vecbuf_enableintegritycheck.F90
     cho_vecbuf_final.F90
     cho_vecbuf_ini2.F90
     cho_vecbuf_init.F90
     cho_vecbuf_init_i.F90
     cho_vecbuf_init_x.F90
     cho_vecbuf_integrity_ok.F90
     cho_vecbuf_maintain.F90
     cho_vecbuf_print.F90
     cho_vecbuf_prtref.F90
     cho_vecbuf_retrieve.F90
     cho_vecdsk_getlq.F90
     cho_vecrd.F90
     cho_vecrd1.F90
     cho_vectransp.F90
     cho_vtra.F90
     cho_word2byte.F90
     cho_wrbuf.F90
     cho_wrfvec.F90
     cho_wrrstc.F90
     cho_x_bookmark.F90
     cho_x_calcchodiag.F90
     cho_x_calculategmat.F90
     cho_x_checkdiag.F90
     cho_x_compvec.F90
     cho_x_dealloc.F90
     cho_x_defineinfvec_5.F90
     cho_x_final.F90
     cho_x_genvec.F90
     cho_x_get_pardiag.F90
     cho_x_gettol.F90
     cho_x_gettotv.F90
     cho_x_getvfull.F90
     cho_x_getvtra.F90
     cho_x_init.F90
     cho_x_init_par.F90
     cho_x_init_par_cho.F90
     cho_x_init_par_df.F90
     cho_x_init_par_genbak.F90
     cho_x_numrd.F90
     cho_x_nvecrs.F90
     cho_x_rdrst.F90
     cho_x_reovec.F90
     cho_x_rscopy.F90
     cho_x_rsswap.F90
     cho_x_setinc.F90
     cho_x_setred.F90
     cho_x_test.F90
     cho_x_vecrd.F90
     cho_xcv_closeanderasetmpfiles.F90
     cho_xcv_closeandkeeptmpfiles.F90
     cho_xcv_distrib_sp.F90
     cho_xcv_distributevectors.F90
     cho_xcv_dv_p.F90
     cho_xcv_dv_s.F90
     cho_xcv_getint.F90
     cho_xcv_opentmpfiles.F90
     cho_xcv_rdvec.F90
     cho_xcv_rdvec_.F90
     cho_xcv_tmpfiles.F90
     cho_xcv_wrvec.F90
     cho_xcv_wrvec_par.F90
     cho_xcv_wrvec_ser.F90
     cho_zmem.F90
     chodec.F90
     chodec_mxvec.F90
     cholesky.F90
     cholesky_procedures.F90
     cholesky_structures.F90
     cholsosmp2_energy.F90
     cholsosmp2_energy_fll.F90
     cholsosmp2_energy_fll1.F90
     cholsosmp2_energy_fll2.F90
     cholsosmp2_energy_srt.F90
     chomp2.F90
     chomp2_ampfromint.F90
     chomp2_backtra.F90
     chomp2_checkbacktra.F90
     chomp2_col.F90
     chomp2_col_comp.F90
     chomp2_col_cp.F90
     chomp2_col_invai.F90
     chomp2_deallocate.F90
     chomp2_decchk.F90
     chomp2_decchk_1.F90
     chomp2_decchk_2.F90
     chomp2_decchk_int.F90
     chomp2_decdrv.F90
     chomp2_drv.F90
     chomp2_energy.F90
     chomp2_energy_contr.F90
     chomp2_energy_contr_t1.F90
     chomp2_energy_fll.F90
     chomp2_energy_getind.F90
     chomp2_energy_getpqind.F90
     chomp2_energy_org.F90
     chomp2_energy_prt.F90
     chomp2_energy_srt.F90
     chomp2_fno.F90
     chomp2_fno_fll.F90
     chomp2_fno_org.F90
     chomp2_fno_srt.F90
     chomp2_getbasenm.F90
     chomp2_getinf.F90
     chomp2_intcol.F90
     chomp2_moreord.F90
     chomp2_o4_drv.F90
     chomp2_openb.F90
     chomp2_openf.F90
     chomp2_read_batch.F90
     chomp2_setup.F90
     chomp2_setup_index.F90
     chomp2_setup_memchk.F90
     chomp2_setup_prt.F90
     chomp2_srt.F90
     chomp2_srtdrv.F90
     chomp2_tra.F90
     chomp2_tra_1.F90
     chomp2_tradrv.F90
     chomp2_travec.F90
     chomp2_vec.F90
     chomp2_vectormo2ao.F90
     chomp2g_ampdiag.F90
     chomp2g_constrap.F90
     chomp2g_deallocate.F90
     chomp2g_densdrv.F90
     chomp2g_density1.F90
     chomp2g_density2.F90
     chomp2g_density3.F90
     chomp2g_gradsetup.F90
     chomp2g_moreord.F90
     chomp2g_reord_r.F90
     chomp2g_setup.F90
     chomp2g_tra.F90
     chomp2g_tra_1.F90
     chomp2g_tradrv.F90
     chomp2g_travec.F90
     ckaltd.F90
     ckaltt.F90
     conj_grad.F90
     decomat.F90
     dfinek.F90
     dfmp2e.F90
     expsum.F90
     fdextr.F90
     findam.F90
     findmx.F90
     funcla.F90
     funcle.F90
     get_ldfaccuracy.F90
     getdr1.F90
     getdr2.F90
     glasum.F90
     glesum.F90
     incrsort.F90
     indsft_cho.F90
     indsft_cho_2.F90
     indsft_cho_3.F90
     indsft_cho_diag.F90
     initt.F90
     integral_wrout_cho.F90
     integral_wrout_cho_diag.F90
     laplace_prsq.F90
     minimaxlaplace.F90
     onecenter_chkdiag.F90
     plf_cho.F90
     plf_cho_2.F90
     plf_cho_3.F90
     plf_cho_diag.F90
     ptdiff.F90
     quaderr.F90
     remez.F90
     remez_mod.F90
     remez_setupprint.F90
     remez_shutdownprint.F90
     setexp.F90
     slveqs.F90
     slvnt1.F90
     slvnt2.F90
     statistics.F90
     sumlag.F90
     sumleg.F90
     switch_density.F90
     testminimaxlaplace.F90
     updatemostnegative.F90
)

# Source files defining modules that should be available to other *_util directories
set (modfile_list
     cholesky.F90
     cholesky_structures.F90
)

include (${PROJECT_SOURCE_DIR}/cmake/util_template.cmake)

=== debian/changelog ===
openmolcas (23.10-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:03:12 +1100

openmolcas (23.10-1build1) noble; urgency=medium

  * No-change rebuild against libhdf5-103-1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 18:02:12 +0000

openmolcas (23.10-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/mkl_library_dir.patch: Refreshed.
  * debian/patches/pymolcas_default_directories.patch: Likewise.
  * debian/patches/install_locations.patch: Likewise.
  * debian/patches/libxc_hardcode_includedir.patch: Likewise.
  * debian/patches/pyparsing_3.1.1.patch: New patch, makes pymolcas work with
    pyparsing-3.1.1, taken from upstream commit df2d6a4.

 -- Michael Banck <mbanck@debian.org>  Sat, 02 Dec 2023 23:47:01 +0100

=== debian/control ===
Source: openmolcas
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: debhelper (>= 10),
               cmake (>= 3.0.2),
               gfortran,
               libhdf5-dev,
               libopenblas64-openmp-dev,
               libjs-jquery,
               libjs-underscore,
               libxc-dev (>= 5.2.2),
               python3-pyparsing,
               python3-six,
               python3-sphinx,
               python3-sphinxcontrib.bibtex
Standards-Version: 4.1.3
X-Python3-Version: >= 3.6
Homepage: https://gitlab.com/Molcas/OpenMolcas
Testsuite: autopkgtest-pkg-python
Vcs-Browser: https://salsa.debian.org/debichem-team/openmolcas
Vcs-Git: https://salsa.debian.org/debichem-team/openmolcas.git

Package: openmolcas
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${perl:Depends},
         openmolcas-data (= ${source:Version}),
         python3,
         python3-lxml,
         python3-pyparsing,
         python3-six
Description: Quantum chemistry software package
 The key feature of OpenMolcas is the multiconfigurational approach to the
 electronic structure.
 .
 It can compute energies, gradients and hessians for the following methods:
  * Hartree-Fock SCF (HF)
  * Complete active space SCF (CASSCF)
 .
 It can compute energies and gradients for the following methods:
  * Hartree-Fock (HF)
  * Density-Functional Theory (DFT)
  * Second-order Moeller-Plesset perturbation theory (MP2)
  * Complete and restricted active space SCF (CASSCF/RASSCF)
 .
 Additionally, it can compute energies for the following methods:
  * Closed shell Moeller-Plesset perturbation theory (MP2)
  * Complete active space second order perturbation theory (CASPT2)
  * Coupled-cluster singles doubles (CCSD), optionally wihth
    Cholesky-Decomposition (CD)/Resolution-of-the Identity (RI)
  * CD/RI Coupled-cluster singles doubles with perturbative
    triples (CCSD(T))
  * Density Matrix Renormalization Group SCF (DMRG-SCF)

Package: openmolcas-data
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Quantum chemistry software package (data files)
 The key feature of OpenMolcas is the multiconfigurational approach to the
 electronic structure.
 .
 This package contains data files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LINALG=openblas64-openmp

export FFLAGS=$(shell dpkg-buildflags --get FFLAGS) -ffp-contract=off

%:
	dh $@ --buildsystem=cmake --with sphinxdoc

override_dh_auto_configure:
	dh_auto_configure --		\
		-DTOOLS=ON		\
		-DOPENMP=ON		\
		-DHDF5=ON		\
		-DLINALG=Manual		\
		-DLINALG_LIBRARIES=/usr/lib/${DEB_HOST_MULTIARCH}/${LINALG}/liblapack64.so:/usr/lib/${DEB_HOST_MULTIARCH}/${LINALG}/libblas64.so \
		-DEXTERNAL_LIBXC=/usr/lib/${DEB_HOST_MULTIARCH} \
		-DCMAKE_SKIP_RPATH=ON

override_dh_auto_install:
	dh_auto_install
	cp -a test debian/tmp/usr/share/openmolcas
